## python3.11 3.11.0~rc1

=== Doc/requirements.txt ===
# Requirements to build the Python documentation

# Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
sphinx==4.5.0

blurb

sphinx-lint<1

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2022.1

=== debian/changelog ===
python3.11 (3.11.0~rc1-1~22.04) jammy-proposed; urgency=medium

  * SRU: LP: #1985085: Backport 3.11 to 20.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Aug 2022 12:02:14 +0200

python3.11 (3.11.0~rc1-1) unstable; urgency=medium

  * Python 3.11.0 release candidate 1.
  * Add python3.11-venv as a dependency for the testsuite* autopkg tests.
  * Don't run the cppext test during the build.
  * Fix two site and sysconfig tests.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Aug 2022 13:16:05 +0200

python3.11 (3.11.0~b4-2) unstable; urgency=medium

  * Work around https://github.com/pypa/pip/issues/11183.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Jul 2022 12:00:00 +0200

python3.11 (3.11.0~b4-1) unstable; urgency=medium

  * Python 3.11.0 beta 4 snapshot.
  * Fix more references to 3.11 in the autopkg tests.
  * Update local-doc-references patch for 3.11.
  * Remove i386 specific symbols files.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Jul 2022 11:00:16 +0200

python3.11 (3.11.0~b3-2) unstable; urgency=medium

  * Update symbols files for i386.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jun 2022 16:59:45 +0200

python3.11 (3.11.0~b3-1) unstable; urgency=medium

  * Python 3.11.0 beta 3 snapshot.
  * Refresh patches.
  * Update symbols files.
  * Adjust the minimal set (re now a package), make the ntpath import
    conditional.
  * Update autopkg tests for 3.11.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Jun 2022 12:09:22 +0200

python3.10 (3.10.4-4) unstable; urgency=medium

  * Source-only upload.
  * Backport gh-78214: marshal: Stabilize FLAG_REF usage. Closes: #1010368.

 -- Matthias Klose <doko@debian.org>  Fri, 13 May 2022 14:08:11 +0200

python3.10 (3.10.4-3) unstable; urgency=medium

  * Build a python3.10-nopie package, diverting the python3.10
    executable.
  * Build the python3.10 interpreter with PIE enabled. Closes: ##919134.
    LP: #1452115.
  * Fix build on ia64 (Adrian Glaubitz). Closes: #1008576.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Apr 2022 11:04:19 +0200

python3.10 (3.10.4-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Avoid infinite recursion in _distutils_system_mod when
    SETUPTOOLS_USE_DISTUTILS=local.
  * Avoid crashing in `_distutils_system_mod` if we find an older version of
    distutils (from before `_distutils_system_mod` was implemented).

 -- Matthias Klose <doko@debian.org>  Fri, 01 Apr 2022 17:03:31 +0200

python3.10 (3.10.4-1) unstable; urgency=medium

  * Python 3.10.4 release.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Mar 2022 14:07:27 +0100

python3.10 (3.10.3-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Change the "include" and "platinclude" paths in the "posix_local"
    scheme to refer to the location of Python's headers, not the install
    location for modules' C headers. Closes: #1007966

  [ Matthias Klose ]
  * Allow to build with PIE enabled by default, and build a separate
    python3.10-nopie package. Not yet enabled for Debian.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Mar 2022 12:42:32 +0100

python3.10 (3.10.3-1) unstable; urgency=medium

  * Python 3.10.3 release.

 -- Matthias Klose <doko@debian.org>  Wed, 16 Mar 2022 18:19:40 +0100

python3.10 (3.10.2-7) unstable; urgency=medium

  [ Stefano Rivera ]
  * Use the same is_virtual_environment() proposed in PEP 668 across the site,
    sysconfig, and distutils modules. Stop checking for PYTHONUSERBASE or
    VIRTUAL_ENV environment variables.
  * Correct assertion descriptions in module-install-* autopkgtests.
  * Extend module-install-* autopkgtests to catch the issues fixed in -6:
    - Check the directory that the modules are installed to.
    - Check editable installs.
    - Check pip-driven PEP-517 installs.
    - Check that virtualenvs are seeded with the correct layout.
  * Re-enable module-install-virtualenv.

 -- Matthias Klose <doko@debian.org>  Mon, 14 Mar 2022 06:18:40 +0100

python3.10 (3.10.2-6) unstable; urgency=medium

  [ Matthias Klose ]
  * Update to the 3.10 branch 2022-03-13.
  * Add the test_multiprocessing_fork test to the failing autopkg tests,
    and run them with a 2h timeout.
  * Don't run the test_multiprocessing tests in the profile run.

  [ Stefano Rivera ]
  * Re-add accidentally dropped /local/ to paths in distutils unix_local
    scheme.
  * Add missing /local/ to data path in sysconfig posix_local scheme.
    LP: #1964588.
  * Improve support for setuptools > 60's bundled distutils in
    _distutils_system_mod, supporting a wider range of versions and more
    reliably selecting the posix_local scheme. Closes: #1004149.
  * Use the same heuristics for scheme selection in sysconfig, as we use in
    distutils.command.install. Closes: #1006707, LP: #1962791.
  * Run the test suite with a 1hr timeout per module. Closes: #1000188.

 -- Matthias Klose <doko@debian.org>  Sun, 13 Mar 2022 07:20:35 +0100

python3.10 (3.10.2-5) unstable; urgency=medium

  * Fix the marshal test after applying the fix for #1004558.

 -- Matthias Klose <doko@debian.org>  Sat, 26 Feb 2022 09:21:15 +0100

python3.10 (3.10.2-4) unstable; urgency=medium

  * Provide a _distutils_system_mod module to customize distutils behaviour
    for Debian's install layout (Stefano Rivera).

 -- Matthias Klose <doko@debian.org>  Fri, 25 Feb 2022 22:04:33 +0100

python3.10 (3.10.2-3) unstable; urgency=medium

  * Apply again the updated sysconfig-debian-schemes patch (Alexandre Ghiti).

 -- Matthias Klose <doko@debian.org>  Fri, 25 Feb 2022 21:13:53 +0100

python3.10 (3.10.2-2) unstable; urgency=medium

  * Make test suite support Expat >=2.4.5. Closes: #1006219.
  * Build again using readline instead of libedit. Closes: #1005761.
  * Serialize frozenset elements deterministically, taken from the trunk.
    Closes: #1004558.

 -- Matthias Klose <doko@debian.org>  Tue, 22 Feb 2022 14:57:42 +0100

python3.10 (3.10.2-1) unstable; urgency=medium

  * Python 3.10.2 release.

  [ Stefano Rivera ]


=== debian/control ===
Source: python3.11
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev | libeditreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.5.1~),
  libbluetooth-dev [linux-any] <!pkg.python3.11.nobluetooth>,
  locales-all,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.11:any <cross>,
  net-tools, xvfb <!nocheck>, xauth <!nocheck>,
  systemtap-sdt-dev
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.11
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.11-minimal (= ${binary:Version}),
 libpython3.11-stdlib (= ${binary:Version}),
 media-types | mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.11-venv, python3.11-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.11)
 Python is a high-level, interactive, object-oriented language. Its 3.11 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.11-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.11 (= ${binary:Version}),
 python3-pip-whl,
 python3-setuptools-whl,
 python3.11-distutils,
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.11)
 Python is a high-level, interactive, object-oriented language. Its 3.11 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.11 binary.

Package: libpython3.11-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.11-minimal (= ${binary:Version}),
  media-types | mime-support,
  ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-gdbm (<< 3.9.9-1~)
Replaces: python3-gdbm (<< 3.9.9-1~)
Description: Interactive high-level object-oriented language (standard library, version 3.11)
 Python is a high-level, interactive, object-oriented language. Its 3.11 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.11's standard library. It is normally not
 used on its own, but as a dependency of python3.11.

Package: python3.11-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.11-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.11
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.11)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.11-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.11

Package: python3.11-nopie
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.11-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Python interpreter linked without PIE (version 3.11)
 This package contains the interpreter not built as position independent
 executable. This interpreter is diverting the python3.11 executable, and making
 the interpreter built with PIE available as python3.11-pie.
XB-Cnf-Visible-Pkgname: python3.11

Package: libpython3.11-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.11-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.11)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.11-minimal.

Package: libpython3.11
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.11-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.11)
 Python is a high-level, interactive, object-oriented language. Its 3.11 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.11-examples
Architecture: all
Depends: python3.11:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.11)
 Examples, Demos and Tools for Python (v3.11). These are files included in
 the upstream Python distribution (v3.11).

Package: python3.11-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.11 (= ${binary:Version}),
  libpython3.11-dev (= ${binary:Version}),
  libpython3.11 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.11)
 Header files, a static library and development tools for building
 Python (v3.11) modules, extending the Python interpreter or embedding
 Python (v3.11) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.11-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.11-stdlib (= ${binary:Version}),
  libpython3.11 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.11)
 Header files, a static library and development tools for building
 Python (v3.11) modules, extending the Python interpreter or embedding
 Python (v3.11) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.11-dev.

Package: libpython3.11-testsuite
Section: libdevel
Architecture: all
Depends: python3.11 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.11)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.11-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.11-stdlib package).

Package: idle-python3.11
Architecture: all
Depends: python3.11, python3-tk, python3.11-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.11
Description: IDE for Python (v3.11) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.11).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.11-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.11
Description: Documentation for the high-level object-oriented language Python (v3.11)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.11). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.11
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.11-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.11 (= ${binary:Version}), libpython3.11-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.11)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.11-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.11-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-gdbm-dbg (<< 3.9.9-1~)
Replaces: python3-gdbm-dbg (<< 3.9.9-1~)
Description: Debug Build of the Python Interpreter (version 3.11)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.11-full
Architecture: any
Multi-Arch: allowed
Depends: python3.11 (= ${binary:Version}),
  libpython3.11-testsuite,
  python3.11-venv (= ${binary:Version}),
  idle-python3.11,
  python3.11-distutils,
  python3.11-gdbm,
  python3.11-lib2to3,
  python3.11-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.11-doc, python3.11-examples,
Suggests: python3.11-dev
Description: Python Interpreter with complete class library (version 3.11)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv and distutils, and modules with
 complex dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)"dpkg-buildflags
ifeq (,$(filter $(distrelease),stretch buster bullseye trusty xenial bionic focal impish))
  with_nopie := yes
  dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
endif

# FIXME: remove sid when uploading to unstable, after bookworm is released
#ifneq (,$(filter $(distrelase), jessie stretch buster bullseye bookworm sid precise trusty xenial bionic focal groovy hirsute))
  with_dbmmodule = yes
  bd_dbm = libdb-dev
  dbmliborder = bdb:gdbm
#else
#  bd_dbm = libgdbm-compat-dev
#  dbmliborder = gdbm:bdb
#endif

VER=3.11
SVER=3.11.0~b4
NVER=3.12
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

DPKG_PIE_CPPFLAGS= $(shell $(dpkg_pieflags) --get CPPFLAGS)
DPKG_PIE_CFLAGS  := $(shell $(dpkg_pieflags) --get CFLAGS)
DPKG_PIE_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_PIE_CFLAGS))
DPKG_PIE_LDFLAGS = $(shell $(dpkg_pieflags) --get LDFLAGS)
OPT_PIE_CFLAGS   := $(filter-out -O%,$(DPKG_PIE_CFLAGS)) # default is -O3

ifeq ($(DEB_HOST_ARCH),ia64)
    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
endif
# see #972202, and https://gcc.gnu.org/PR97431
ifneq (,$(filter $(DEB_HOST_ARCH), hppa sh4))
    EXTRA_OPT_CFLAGS += -fno-inline-small-functions
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

BASE_LTO_CFLAGS = -g -fwrapv -O3
ifeq ($(with_lto),yes)
    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \

## python3.11 3.11.0~rc2

=== debian/changelog ===
python3.11 (3.11.0~rc2-1) unstable; urgency=medium

  * Python 3.11.0 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Sep 2022 18:20:24 +0200

## python3.11 3.11.2

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
SPHINXLINT   = PATH=$(VENVDIR)/bin:$$PATH sphinx-lint
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
JOBS         = auto
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
SPHINXERRORHANDLING = -W

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees $(PAPEROPT_$(PAPER)) -j $(JOBS) \
                $(SPHINXOPTS) $(SPHINXERRORHANDLING) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text texinfo changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  texinfo    to make Texinfo file"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif $(BLURB) help >/dev/null 2>&1 && $(SPHINXBUILD) --version >/dev/null 2>&1; then \
		if [ -d ../Misc/NEWS.d ]; then \
			echo "Building NEWS from Misc/NEWS.d with blurb"; \
			$(BLURB) merge -f build/NEWS; \
		else \
			echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
			exit 1; \
		fi \
	else \
		echo ""; \
		echo "Missing the required blurb or sphinx-build tools."; \
		echo "Please run 'make venv' to install local copies."; \
		echo ""; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

texinfo: BUILDER = texinfo
texinfo: build
	@echo "Build finished; the python.texi file is in build/texinfo."
	@echo "Run \`make info' in that directory to run it through makeinfo."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }
	@echo "⚠ make suspicious is deprecated and will be removed soon."
	@echo "⚠ Use:"
	@echo "⚠     make check"
	@echo "⚠ instead."

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	$(PYTHON) -c "import os, webbrowser; webbrowser.open('file://' + os.path.realpath('build/html/index.html'))"

clean: clean-venv
	-rm -rf build/*

clean-venv:
	rm -rf $(VENVDIR)

venv:
	@if [ -d $(VENVDIR) ] ; then \
		echo "venv already exists."; \
		echo "To recreate it, remove it first with \`make clean-venv'."; \
	else \
		$(PYTHON) -m venv $(VENVDIR); \
		$(VENVDIR)/bin/python3 -m pip install -U pip setuptools; \
		$(VENVDIR)/bin/python3 -m pip install -r requirements.txt; \
		echo "The venv has been created in the $(VENVDIR) directory"; \
	fi

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

	# archive the texinfo build
	rm -rf build/texinfo
	make texinfo
	make info --directory=build/texinfo
	cp -pPR build/texinfo dist/python-$(DISTVERSION)-docs-texinfo
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-texinfo.tar python-$(DISTVERSION)-docs-texinfo
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-texinfo.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-texinfo.zip python-$(DISTVERSION)-docs-texinfo)
	rm -r dist/python-$(DISTVERSION)-docs-texinfo
	rm dist/python-$(DISTVERSION)-docs-texinfo.tar

check:
	# Check the docs and NEWS files with sphinx-lint.
	# Ignore the tools and venv dirs and check that the default role is not used.
	$(SPHINXLINT) -i tools -i $(VENVDIR) --enable default-role
	$(SPHINXLINT) --enable default-role ../Misc/NEWS.d/next/

serve:
	@echo "The serve target was removed, use htmlview instead (see bpo-36329)"

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== Doc/requirements.txt ===
--- 
+++ 
@@ -7,7 +7,8 @@
 
 blurb
 
-sphinx-lint<1
+sphinx-lint==0.6.7
+sphinxext-opengraph>=0.7.1
 
 # The theme used by the documentation is stored separately, so we need
 # to install that as well.

=== debian/changelog ===
python3.11 (3.11.2-6+deb12u6) bookworm; urgency=medium

  * Non-maintainer upload.
  * CVE-2025-0938: urlparse accepted hostname containing [ or ]
  * CVE-2025-1795: Don't encode list separators in email headers

 -- Adrian Bunk <bunk@debian.org>  Mon, 28 Apr 2025 17:11:48 +0300

python3.11 (3.11.2-6+deb12u5) bookworm; urgency=medium

  * Non-maintainer upload.
  * CVE-2023-27043: Reject malformed addresses in email.parseaddr()
    (Closes: #1059298)
  * CVE-2024-6923: Encode newlines in headers in the email module
  * CVE-2024-7592: Quadratic complexity parsing cookies with backslashes
  * CVE-2024-9287: venv activation scripts did't quote paths
  * CVE-2024-11168: urllib functions improperly validated bracketed hosts

 -- Adrian Bunk <bunk@debian.org>  Sat, 30 Nov 2024 23:22:50 +0200

python3.11 (3.11.2-6+deb12u4) bookworm; urgency=medium

  * Fix zipfile.Path regression introduced by 3.11.2-6+deb12u3
    (Closes: 1080245)
  * Fix CVE-2024-6232: Regular expressions that allowed excessive backtracking
    during tarfile.TarFile header parsing are vulnerable to ReDoS via
    specifically-crafted tar archives

 -- Santiago Ruano Rincón <santiagorr@riseup.net>  Sat, 14 Sep 2024 00:00:30 -0300

python3.11 (3.11.2-6+deb12u3) bookworm-security; urgency=medium

  * CVE-2024-0397 
  * CVE-2024-4032
  * CVE-2024-8088

 -- Moritz Mühlenhoff <jmm@debian.org>  Mon, 26 Aug 2024 09:20:54 +0200

python3.11 (3.11.2-6+deb12u2) bookworm; urgency=medium

  [ Steve McIntyre ]
  * Apply upstream security fix for CVE-2024-0450
    Protect zipfile from "quoted-overlap" zipbomb.
    Closes: #1070133
  * Apply and tweak upstream security fix for CVE-2023-6597
    tempfile.TemporaryDirectory: fix symlink bug in cleanup
    Closes: #1070135

  [ Stefano Rivera ]
  * Apply upstream patch to avoid a potential null pointer dereference in
    fileutils.
  * Apply upstream security fix for CVE-2023-41105
    os.path.normpath(): Path truncation at null bytes.
  * Apply upstream security fix for CVE-2023-40217
    Avoid bypass TLS of handshake protections on closed sockets.
  * Apply upstream security fix for CVE-2023-24329
    Strip C0 control and space characters in urlsplit.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 02 May 2024 07:59:08 -0400

python3.11 (3.11.2-6+deb12u1) bookworm; urgency=medium

  [ Anders Kaseorg ]
  * Fix a use-after-free crash when deallocating a frame object
    (closes: #1050843).

 -- Stefano Rivera <stefanor@debian.org>  Sat, 02 Mar 2024 16:28:50 -0400

python3.11 (3.11.2-6) unstable; urgency=high

  [ Stefano Rivera ]
  * Explain more ways to pass --break-system-packages to pip.

  [ Matthias Klose ]
  * Fix syntax error in python3-dbg-config script. LP: #2009967.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Mar 2023 13:18:29 +0100

python3.11 (3.11.2-5) unstable; urgency=medium

  [ Matthias Klose ]
  * Update VCS attributes.
  * Fix error message for 'python3 -m venv dir`, when python3-venv
    is not installed. Closes: #1026268.

  [ Stefano Rivera ]
  * Mention that deleting EXTERNALLY-MANAGED is an option, in README.venv.
  * Patch: fix deadlock at shutdown when clearing thread states.
    Closes: #1032019.
  * Override expat embedded-library lintian false-positives. (See: #1031859)

 -- Matthias Klose <doko@debian.org>  Sun, 05 Mar 2023 09:28:49 +0100

python3.11 (3.11.2-4) unstable; urgency=medium

  [ Stefano Rivera ]
  * Revert the CCSHARED patch to test_customize_compiler, this was WIP and
    didn't work.

  [Matthias Klose]
  * Remove build dependency on libb2-dev, oldish library.
  * Build with internal mpdecimal library, so that mpdecimal can be removed
    for bookworm.

 -- Matthias Klose <doko@debian.org>  Sun, 12 Feb 2023 01:48:52 +0100

python3.11 (3.11.2-3) unstable; urgency=medium

  [ Stefano Rivera ]
  * Refresh patches.
  * Revert pip importlib.metadata workaround, fixed in pip 22.2.
  * Declare python3.11 to be PEP 668 EXTERNALLY-MANAGED.
  * Update and install README.venv, explaining this.
  * Recommend ca-certificates from python3.11. Closes: #960869.
  * Configure --with-ssl-default-suites=openssl. Closes: #1026802.
  * Update watch file.
  * Include CCSHARED override in distutils test_customize_compiler.

  [Matthias Klose]
  * Really new upstream version.
  * Configure --with-ssl-default-suites=openssl. Closes: #1009189.
  * Build-depend on libb2-dev.
  * Fix removing Debian build flags from _sysconfigdata. LP: #2006738.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Feb 2023 05:59:34 +0100

python3.11 (3.11.2-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 06 Feb 2023 21:27:04 +0100

python3.11 (3.11.1-2) unstable; urgency=medium

  * Fix NameError exception in venv init (Daniel Andersson). Closes: #1026448.
  * Fix FTCBFS: Pass --with-build-python (Helmut Grohne). Closes: #1024297.

 -- Matthias Klose <doko@debian.org>  Sat, 31 Dec 2022 11:23:59 +0100

python3.11 (3.11.1-1) unstable; urgency=medium

  * Python 3.11.1 release.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Dec 2022 09:49:13 +0100

python3.11 (3.11.0-3) unstable; urgency=medium

  * Fix valgrind detection.

 -- Matthias Klose <doko@debian.org>  Fri, 04 Nov 2022 10:23:33 +0100

python3.11 (3.11.0-2) unstable; urgency=medium

  * Update to the 3.11 branch 2022-11-03.
    - debian/patches/CVE-2022-42919.patch: don't use Linux abstract sockets
      in Lib/multiprocessing/connection.py.
    - CVE-2022-42919
  * Fix GDB auto-load files. Closes: #1017913.
  * Add support for systemd-binfmt. Closes: #1013973.
  * libpython3.11-dev: Install Python.asdl and python.gram. Closes: #1022951.
  * Configure the python3-dbg interpreter --with-valgrind. Closes: #1006315.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Nov 2022 16:41:50 +0100

python3.11 (3.11.0-1) unstable; urgency=medium

  * Python 3.11.0 release.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Mon, 24 Oct 2022 23:26:25 +0200



=== debian/rules ===
--- 
+++ 
@@ -95,8 +95,12 @@
 #  dbmliborder = gdbm:bdb
 #endif
 
+ifneq (,$(filter valgrind, $(shell dpkg-query --show -f '$${Depends}\n' valgrind-if-available)))
+  valgrind_configure_args = --with-valgrind
+endif
+
 VER=3.11
-SVER=3.11.0~b4
+SVER=3.11.0
 NVER=3.12
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
@@ -227,5 +231,3 @@
 
 BASE_LTO_CFLAGS = -g -fwrapv -O3
 ifeq ($(with_lto),yes)
-    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
-    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.11-dev,
  libpython3.11-testsuite:native,
  python3-gdbm (>= 3.9.7),
  python3-distutils,
  python3-tk (>= 3.9.7),
  idle-python3.11,
  systemtap-sdt-dev,
  python3.11-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: testsuite-dbg
Depends: build-essential,
  ca-certificates,
  locales-all, python3.11-dev,
  python3.11-dbg,
  libpython3.11-testsuite:native,
  python3-gdbm-dbg (>= 3.9.7),
  gdb,
  python3-distutils,
  python3-tk-dbg (>= 3.9.7),
  idle-python3.11,
  systemtap-sdt-dev,
  python3.11-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.11-dev,
  libpython3.11-testsuite:native,
  python3-gdbm (>= 3.9.7),
  python3-tk (>= 3.9.7),
  python3-distutils,
  python3.11-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.11-dev,
  python3.11-dbg,
  libpython3.11-testsuite:native,
  python3-gdbm-dbg (>= 3.9.7),
  python3-tk-dbg (>= 3.9.7),
  gdb,
  python3-distutils,
  python3.11-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: module-install-local
Depends: build-essential,
  python3.11-dev,
  python3-pip,
  python3-setuptools,
  shunit2,
Restrictions: needs-root, allow-stderr

Tests: module-install-user
Depends: build-essential,
  python3.11-dev,
  python3-pip,
  python3-setuptools,
  shunit2
Restrictions: allow-stderr

Tests: module-install-venv
Depends: build-essential,
  python3.11-dev,
  python3.11-venv,
  python3-wheel-whl,
  shunit2
Restrictions: allow-stderr

Tests: module-install-virtualenv
Depends: build-essential, python3.11-dev, shunit2, virtualenv
Restrictions: allow-stderr

## python3.11 3.11.4

=== debian/changelog ===
python3.11 (3.11.4-1~23.04) lunar-proposed; urgency=medium

  * SRU: LP: #2019538. Backport 3.11.4 to 23.04.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 09 Jun 2023 09:59:55 +0200

python3.11 (3.11.4-1) unstable; urgency=medium

  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Jun 2023 12:13:09 +0200

python3.11 (3.11.3-2) experimental; urgency=medium

  * Update to the 3.11 branch 2023-05-30.

 -- Matthias Klose <doko@debian.org>  Tue, 30 May 2023 14:15:02 +0200

python3.11 (3.11.3-1) experimental; urgency=medium

  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Tue, 11 Apr 2023 10:25:20 +0200

## python3.11 3.11.5

=== debian/changelog ===
python3.11 (3.11.5-2) unstable; urgency=medium

  * libpython3.11-stdlib: Also depend on tzdata-legacy. Closes: #1050530.
  * Add loongarch support. Closes: #1049963.

 -- Matthias Klose <doko@debian.org>  Sat, 26 Aug 2023 20:28:17 +0200

python3.11 (3.11.5-1) unstable; urgency=medium

  * New upstream release.
    - Address CVE-2023-41105.
  * libpython3.11-stdlib: Depend on tzdata. Closes: #1037168.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Fri, 25 Aug 2023 09:43:52 +0200

=== debian/control ===
--- 
+++ 
@@ -9,18 +9,19 @@
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
-  libexpat1-dev, libmpdec-dev (>= 2.5.1~),
+  libexpat1-dev,
   libbluetooth-dev [linux-any] <!pkg.python3.11.nobluetooth>,
   locales-all,
   libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
   libgpm2 [linux-any],
   media-types | mime-support, netbase, bzip2, time, python3:any, python3.11:any <cross>,
   net-tools, xvfb <!nocheck>, xauth <!nocheck>,
-  systemtap-sdt-dev
+  systemtap-sdt-dev,
+  valgrind-if-available,
 Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
-Standards-Version: 4.6.0
-Vcs-Browser: https://salsa.debian.org/cpython-team/python3
-Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
+Standards-Version: 4.6.2
+Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.11
+Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.11
 XS-Testsuite: autopkgtest
 
 Package: python3.11
@@ -31,6 +32,7 @@
  libpython3.11-stdlib (= ${binary:Version}),
  media-types | mime-support,
  ${shlibs:Depends}, ${misc:Depends}
+Recommends: ca-certificates
 Suggests: python3.11-venv, python3.11-doc, binutils
 Breaks: python3-all (<< 3.6.5~rc1-1),
   python3-dev (<< 3.6.5~rc1-1),
@@ -45,7 +47,7 @@
 Multi-Arch: allowed
 Priority: optional
 Depends: python3.11 (= ${binary:Version}),
- python3-pip-whl,
+ python3-pip-whl (>= 22.2),
  python3-setuptools-whl,
  python3.11-distutils,
  ${shlibs:Depends}, ${misc:Depends},
@@ -63,7 +65,7 @@
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.11-minimal (= ${binary:Version}),
-  media-types | mime-support,
+  media-types | mime-support, tzdata, tzdata-legacy,
   ${shlibs:Depends}, ${misc:Depends}
 Breaks: python3-gdbm (<< 3.9.9-1~)
 Replaces: python3-gdbm (<< 3.9.9-1~)

=== debian/rules ===
--- 
+++ 
@@ -100,7 +100,7 @@
 endif
 
 VER=3.11
-SVER=3.11.0
+SVER=3.11.5
 NVER=3.12
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
